'use strict';

var RelatorioAlmoxarifadoController = angular.module('RelatorioAlmoxarifadoController', []);

RelatorioAlmoxarifadoController.controller('RelatorioAlmoxarifadoCtrl', ['$scope', '$filter', 'Almoxarifado', 'CacheApp',
  ($scope, $filter, Almoxarifado, CacheApp) => {
    $scope.getRelatorioAlmoxarifado = () => {
        var params = {
            IdConstrucao: $scope.construcao.Id,
            Situacao: $scope.filtro.Situacao.Id
        }
        Almoxarifado.getRelatorioAlmoxarifado(params,
            (data) => {
                $scope.listaAlmoxarifado = data.Instance;
            })
    }

    $scope.getSituacaoAlmoxarifado = () => {
        Almoxarifado.getSituacaoAlmoxarifado(
            (data) => {
                $scope.listaSituacao = data.Instance;
                $scope.listaSituacao.unshift({Id: 0, Nome: 'TODOS'});
            }
        );
    }

    $scope.pdfRelatorioAlmoxarifado = () => {
        var cabecalho = {
            Avatar: $scope.construcao.ContaAvatar,
            Obra: $scope.construcao.Titulo,
            Conta: $scope.construcao.Conta,
            DataInicio: $filter("date")($scope.construcao.DataInicio, 'dd/MM/yyyy'),
            DataFim: $filter("date")($scope.construcao.DataFim, 'dd/MM/yyyy'),
            Moeda: $scope.construcao.Moeda
        };

        var params = {
            IdConstrucao: $scope.construcao.Id,
            Situacao: $scope.filtro.Situacao.Id,
            Cabecalho: JSON.stringify(cabecalho)
        }

        Almoxarifado.pdfRelatorioAlmoxarifado(params,
            (data) => {
                window.location.assign(data.Instance);
            });
    }  

    $scope.xlsRelatorioAlmoxarifado = function () {
        var cabecalho = {
            Avatar: $scope.construcao.ContaAvatar,
            Obra: $scope.construcao.Titulo,
            Conta: $scope.construcao.Conta,
            DataInicio: $filter("date")($scope.construcao.DataInicio, 'dd/MM/yyyy'),
            DataFim: $filter("date")($scope.construcao.DataFim, 'dd/MM/yyyy'),
            Moeda: $scope.construcao.Moeda
        }

        var params = {
            IdConstrucao: $scope.construcao.Id,
            Situacao: $scope.filtro.Situacao.Id,
            Cabecalho: JSON.stringify(cabecalho)
        }

        Almoxarifado.xlsRelatorioAlmoxarifado(params,
            (data) => {
                window.location.assign(data.Instance);
            })
    }

    $scope.loadPage = () => {
        $scope.construcao = CacheApp.getConstrucao();

        $scope.filtro = {
            Situacao: {Id: 0, Nome: 'TODOS'}
        };

        $scope.getRelatorioAlmoxarifado();
        $scope.getSituacaoAlmoxarifado();
    }

    $scope.loadPage();

}]);
